Botan: Botan::PK_Verifier_Filter Class Reference

Botan 1.10.17

Public Member Functions | Protected Member Functions | List of all members
Botan::PK_Verifier_Filter Class Reference

`#include <pk_filts.h>`

Inheritance diagram for Botan::PK_Verifier_Filter:

## Public Member Functions
virtual bool | attachable ()
void | end_msg ()
std::string | name () const
| PK_Verifier_Filter (PK_Verifier *v)
| PK_Verifier_Filter (PK_Verifier *, const byte[], size_t)
| PK_Verifier_Filter (PK_Verifier *, const MemoryRegion< byte > &)
void | set_signature (const byte[], size_t)
void | set_signature (const MemoryRegion< byte > &)
virtual void | start_msg ()
void | write (const byte[], size_t)
| ~PK_Verifier_Filter ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

PK_Verifier Filter

Definition at line 77 of file pk_filts.h.

## Constructor & Destructor Documentation

## ◆ PK_Verifier_Filter() [1/3]

Botan::PK_Verifier_Filter::PK_Verifier_Filter | ( | PK_Verifier * | v | ) |
| inline

Definition at line 88 of file pk_filts.h.

88 : verifier(v) {}

## ◆ PK_Verifier_Filter() [2/3]

Botan::PK_Verifier_Filter::PK_Verifier_Filter | ( | PK_Verifier * | v,
|  | const byte | sig[],
|  | size_t | length
| ) |  |

Definition at line 101 of file pk_filts.cpp.

102 :
103 verifier(v), signature(sig, length)
104 {
105 }

## ◆ PK_Verifier_Filter() [3/3]

Botan::PK_Verifier_Filter::PK_Verifier_Filter | ( | PK_Verifier * | v,
|  | const MemoryRegion< byte > & | sig
| ) |  |

Definition at line 110 of file pk_filts.cpp.

111 :
112 verifier(v), signature(sig)
113 {
114 }

## ◆ ~PK_Verifier_Filter()

Botan::PK_Verifier_Filter::~PK_Verifier_Filter | ( |  | ) |
| inline

Definition at line 91 of file pk_filts.h.

91 { delete verifier; }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::PK_Verifier_Filter::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 73 of file pk_filts.cpp.

References Botan::PK_Verifier::check_signature(), Botan::MemoryRegion< T >::empty(), and Botan::Filter::send().

74 {
75 if(signature.empty())
76 throw Invalid_State("PK_Verifier_Filter: No signature to check against");
77 bool is_valid = verifier->check_signature(signature);
78 send((is_valid ? 1 : 0));
79 }
Botan::PK_Verifier::check_signature
bool check_signature(const byte sig[], size_t length)
Definition: pubkey.cpp:301
Botan::MemoryRegion::empty
bool empty() const
Definition: secmem.h:35
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ name()

std::string Botan::PK_Verifier_Filter::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 80 of file pk_filts.h.

80 { return "PK Verifier"; }

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::MemoryRegion< T >::size(), and Botan::Filter::write().

Referenced by Botan::PK_Encryptor_Filter::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:158
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ set_signature() [1/2]

void Botan::PK_Verifier_Filter::set_signature | ( | const byte | sig[],
|  | size_t | length
| ) |  |

Definition at line 84 of file pk_filts.cpp.

References Botan::copy_mem(), and Botan::MemoryRegion< T >::resize().

85 {
86 signature.resize(length);
87 copy_mem(&signature[0], sig, length);
88 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:217
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:22

## ◆ set_signature() [2/2]

void Botan::PK_Verifier_Filter::set_signature | ( | const MemoryRegion< byte > & | sig | ) |

Definition at line 93 of file pk_filts.cpp.

94 {
95 signature = sig;
96 }

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

38 {}

## ◆ write()

void Botan::PK_Verifier_Filter::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 65 of file pk_filts.cpp.

References Botan::PK_Verifier::update().

66 {
67 verifier->update(input, length);
68 }
Botan::PK_Verifier::update
void update(byte in)
Definition: pubkey.h:242

The documentation for this class was generated from the following files:

- src/filters/pk_filts/pk_filts.h
- src/filters/pk_filts/pk_filts.cpp